
rm(list = ls())
library(readr)
library(dplyr)
path = "/Users/uqfouyan/Desktop/QE replication files/Illustration/Bootstrap_CI_table_10"
setwd(path) 

data = read_csv("boot_200.csv")
attach(data)
head(data)

b1 = V1[1:200]; b2 = V2[1:200]

# MRC estimates
# bhat1 = 0.016592; bhat2 = 0.118800
bhat1 = 0.01661; bhat2 = 0.11918

# bias
bias1 = mean(b1) - bhat1; bias2 = mean(b2) - bhat2

## normal-based 95% confidence intervals
nCI.b1L = bhat1 - 1.96*sd(b1); nCI.b1U = bhat1 + 1.96*sd(b1)
nCI.b2L = bhat2 - 1.96*sd(b2); nCI.b2U = bhat2 + 1.96*sd(b2)

c(nCI.b1L, nCI.b1U)
c(nCI.b2L, nCI.b2U)
# (-0.0227, 0.0559), (0.0350, 0.2034)

## 95% bootstrap confidence region
bCI.b1L = 2*bhat1 - quantile(b1, probs = c(0.975), names = F)
bCI.b1U = 2*bhat1 - quantile(b1, probs = c(0.025), names = F)
bCI.b2L = 2*bhat2 - quantile(b2, probs = c(0.975), names = F)
bCI.b2U = 2*bhat2 - quantile(b2, probs = c(0.025), names = F)

c(bCI.b1L, bCI.b1U)
c(bCI.b2L, bCI.b2U)
# (-0.0246, 0.0352), (0.0765, 0.2266)
