
cd "/Users/uqfouyan/Desktop/QE replication files/Illustration"

clear all                                  // clear the memory
capture log close                          // just in case!
set more off                               // pause for the "-more-"               
* log using cracker.log, replace             // start log-file
insheet using Cracker.csv, clear comma     // read data into Stata

* add number of purchase
preserve
bysort id: gen t = _n
order id t y
* export delimited using Cracker_t.csv, replace
restore

* label variables
label variable y "observed choice"

label variable p1 "normalized price of brand 1"
label variable p2 "normalized price of brand 2"
label variable p3 "normalized price of brand 3"
label variable p4 "normalized price of brand 4"

label variable d1 "display or not for brand 1"
label variable d2 "display or not for brand 2"
label variable d3 "display or not for brand 3"
label variable d4 "display or not for brand 4"

label variable f1 "newspaper feature advertisement or not for brand 1"
label variable f2 "newspaper feature advertisement or not for brand 2"
label variable f3 "newspaper feature advertisement or not for brand 3"
label variable f4 "newspaper feature advertisement or not for brand 4"

* data description and summary statistics
describe
codebook

* convert data from wide form to long form
gen Y1 = (y == 1)
gen Y2 = (y == 2)
gen Y3 = (y == 3)
gen Y4 = (y == 4)
gen it = _n
reshape long Y p d f, i(it) j(choice 1 2 3 4)
drop y

* need Stata 16 or above to use cmset, cmclogit, and cmmprobit  
* conditional (multinomial) Logit
cmset it choice
cmclogit Y p d f, vce(cluster id)
nlcom (-1)*_b[d]/_b[p]
nlcom (-1)*_b[f]/_b[p]

* conditional (multinomial) Probit
cmmprobit Y p d f, corr(unstructured) vce(cluster id) 
estat correlation
nlcom (-1)*_b[d]/_b[p]
nlcom (-1)*_b[f]/_b[p]

* log close
